FGETLINE(3)

NAME
fgetline - get a line from a stream

SYNOPSIS
#include <stdio.h>
char *
fgetline(FILE *stream, size_t *len)

DESCRIPTION
The fgetline function returns a pointer to the next line from the stream referenced by stream. The newline character at the end of the line is replaced by a NUL. If len is non-NULL, the length of the line, not counting the terminating NUL, is stored in the memory location it references.

RETURN VALUES
Upon successful completion a pointer is returned; this pointer becomes invalid after the next I/O operation on stream (whether successful or not) or as soon as the stream is closed. Otherwise, NULL is returned. The fgetline function does not distinguish between end-of-file and error; the routines feof(3) and ferror(3) must be used to determine which occurred. If an error occurrs, the global variable errno is set to indicate the error. The end-of-file condition is remembered, even on a terminal, and all subsequent attempts to read will return NULL until the condition is cleared with clearerr(3).

The text to which the returned pointer points may be modified, provided that no changes are made beyond the terminating NUL. These changes are lost as soon as the pointer becomes invalid.

ERRORS

[EBADF]
    The argument stream is not a stream open for reading.

The fgetline function may also fail and set errno for any of the errors specified for the routines fflush(3), malloc(3), read(2), stat(2), or realloc(3).

SEE ALSO
ferror(3), fgets(3), fopen(3), putc(3)

HISTORY
The fgetline function is new.

BUGS
It is not possible to tell whether the final line of an input file was terminated with a newline.